// ModelSwarm.m					majority 33

#import "ModelSwarm.h"
#import <simtools.h>
#import "CountHeads.h"
#import <collections.h>
#import "dimarray.h"
#import "Setter.h"
#import <random.h>


@implementation ModelSwarm  

+createBegin: (id) aZone {
  ModelSwarm * obj;
 id <ProbeMap>  probeMap;

  obj = [super createBegin: aZone];

  // Fill in various simulation parameters with default values.
  obj->numVoters = 11;
  obj->worldXSize = 100;
  obj->worldYSize = 100;
  //  obj->initialDirection = 0.3;
  obj->widthOfSearch = 2;
  obj->beginx= 2;
  obj->beginy=4;
  obj->longestStep=5;
  
   probeMap = [EmptyProbeMap createBegin: aZone];
  [probeMap setProbedClass: [self class]];
   probeMap = [probeMap createEnd];

  [probeMap addProbe: [probeLibrary getProbeForVariable: "worldXSize"
                                    inClass: [self class]]];
                                    
   [probeMap addProbe: [probeLibrary getProbeForVariable: "worldYSize"
                                    inClass: [self class]]];        
                                                              
  [probeMap addProbe: [probeLibrary getProbeForVariable: "numVoters"
                                   inClass: [self class]]]; 
				   
  [probeMap addProbe: [probeLibrary getProbeForVariable: "beginx"
                                   inClass: [self class]]];            
  [probeMap addProbe: [probeLibrary getProbeForVariable: "beginy"
                                   inClass: [self class]]];          				   
				                                       
  //  [probeMap addProbe: [probeLibrary getProbeForVariable: "initialDirection"
  //                                 inClass: [self class]]]; 				                                       
  [probeMap addProbe: [probeLibrary getProbeForVariable: "longestStep"
				    inClass: [self class]]]; 
   
  [probeMap addProbe: [probeLibrary getProbeForVariable: "widthOfSearch"
				    inClass: [self class]]];                                                                    

  [probeLibrary setProbeMap: probeMap For: [self class]];
 

  return obj;
}

-createEnd {
  return [super createEnd];
}

-getVoterList {
  return voterList;
}
   
-getPolicyList {
  return policyList;
}

-getWinnerList {
  return winnerList;
}

-getWorld {
  return world;
}
    
-getSetterList {
  return setterList;
}
    
-buildObjects {

  int y; 

  v[0]= 50; v[1]=51 ;

  sq[0]=beginx; sq[1]=beginy;

  [super buildObjects];  //copied from heatbugs

  world = [Grid2d createBegin: [self getZone]];
  [world setSizeX: worldXSize Y: worldYSize];
  world = [world createEnd];
  [world fillWithObject: nil];
 
 
  current = [PolicyPoint createBegin: [self getZone]];
  [current setWorld: world];
  current = [current createEnd];
  [current setPos: sq];
  [current setPolicyColor: 2];    

  proposal = [PolicyPoint createBegin: [self getZone]];
  [proposal setWorld: world];
  proposal = [proposal createEnd];
  [proposal setPolicyColor: 2];    

  policyList = [List create: [self getZone]];
   
  winnerList = [List create: [self getZone]];
 
  voterList = [List create: [self getZone]];
   
  setterList = [List create: [self getZone]];
 
  for (y = 0; y < numVoters; y ++) {  
    Voter * aVoter;
    aVoter = [Voter createBegin: [self getZone]];
    [aVoter setWorld: world];
    aVoter = [aVoter createEnd];
    [aVoter setVoterColor: 0];
    [voterList addLast: aVoter];
    [aVoter setidnum:y];
    // Uncomment Following to get creation-state information to compare against voter list
    // printf immediately below
    //     [aVoter sayHi];
  }

  //this is included if you want to verify the voter positions in the console output
  //   index=[voterList begin:[self getZone]];
  //   while((aVoter=[index next])){
  //         [aVoter sayHi];
  //         printf("that was from within the voterList!");}  
  //   [index drop];

  aSetter = [Setter createBegin: [self getZone]];
  [aSetter setWorld: world];
  aSetter = [aSetter createEnd];	 
  [aSetter startRNG];      
  [aSetter setInitialDirection: [uniformDblRand getDoubleWithMin: 0 withMax: +2]];
  [aSetter setWidthOfSearch: widthOfSearch];
  [aSetter setLongestStep: longestStep];
  [setterList addLast: aSetter];
  //some graphs seem to insist you give them a list, rather than object, even
  //though there is just one. More clear manuals would help me here.      
      
      
  return self; 
}

-buildActions {

  //Create an ActionGroup to hold the messages

  modelActions = [ActionGroup create: [self getZone]];
  
  [modelActions createActionTo: aSetter message: M(sayHi)];
  
  [modelActions createActionTo:  aSetter  message: M(makeProp:to:): current: proposal];
     
  [modelActions createActionTo:   aSetter    message: M(evaluate:P:C:): (id) voterList: (id)proposal:(id)current];

  //   This causes the winner positions to be displayed in a "stream": 
   [modelActions createActionTo: policyList message: M(addLast:):current]; 

  //  If you instead want to show winners in red and losers in green, comment-out the previous and compile with NO_PIXMAP and  uncomment this:
  //[modelActions createActionTo: policyList message: M(addLast:):proposal]; 




  [modelActions createActionTo: self       message: M(checkToStop)];
  // Make a schedule and insert the ActionGroup as the only action

  modelSchedule = [Schedule createBegin: [self getZone]];
  [modelSchedule setRepeatInterval: 1];
  modelSchedule = [modelSchedule createEnd];
  [modelSchedule at: 0 createAction: modelActions]; 

  return self;

}

-activateIn: (id) swarmContext {

  // Here, we activate the swarm in the context passed in
  // Then we activate our schedule in ourselves

   [super activateIn: swarmContext];
   [modelSchedule activateIn: self];

  return [self getActivity];
}

-checkToStop { 
   if (getCurrentTime() == 500){stop=1;
   //    [[self getActivity] terminate];
      }
   else stop = 0;
    return self;
 }
-(int)getStop {
    return stop;
 }


@end



  


